	.386p
	.model	flat

STACK_SIZE	equ	100h

STACK	segment para stack 'STACK'
	db	(STACK_SIZE) dup(?)
STACK	ends

STACKSIZ	equ	25000


veh_ID			= 0
veh_version		= 2
veh_image_offset	= 4
veh_relocs_offset	= 8
veh_library_offset	= 12
veh_export_offset	= 16
veh_image_length	= 20
veh_relocs_length	= 24
veh_library_length	= 28
veh_export_length	= 32
veh_uc_image_length	= 36
veh_uc_relocs_length	= 40
veh_bss_length		= 44
veh_flags		= 48
veh_entry_point		= 52
veh_stack_point		= 56
veh_resource_offset	= 60
veh_image_comp		= 64
veh_relocs_comp		= 65
VEH_LENGTH		= 66

veh_ic_none		= 0
veh_ic_lzss		= 1
veh_ic_lzh		= 2
veh_ic_max		= 3
veh_rl_none		= 0
veh_rl_lzss		= 1
veh_rl_lzh		= 2
veh_rl_max		= 3

	.data?

huff_bllen_tbl		db	16 dup (?)
huff_len_bits		db	22 dup (?)
huff_ld_bits		db	280 dup (?)
huff_ld_first_tbl	dd	15 dup (?)
huff_len_first_tbl	dd	15 dup (?)
huff_ld_last_tbl	dd	15 dup (?)
huff_len_last_tbl	dd	15 dup (?)
huff_ld_start_tbl	dd	15 dup (?)
huff_len_start_tbl	dd	15 dup (?)
huff_ld_code_tbl	dw	280 dup (?)
huff_len_code_tbl	db	22 dup (?)

__psp		dw	?
_D16InfoSeg	dw	?
svstack	dd	?
	dw	?
fhandle	dd	?
relomem	dd	?
leoffs	dd	?
progmem	dd	?
rlocmem	dd	?
progbsz	dd	?
rlocbsz	dd	?
proghnd	dd	?
rlochnd	dd	?

buff		db	0ach dup (?)

	.data
silent_flag	db	1

	.code

___checksum:
	db	"VP386CHEKSUM        "
_cstart_:
	jmp	short around

;
; copyright message, so that idiot DOS/4GW will run this
;
	db	"WATCOM C/C++32 Run-Time system. "
        db      "(c) Copyright by WATCOM International Corp. 1988-1993."
	db	" All rights reserved."

around:
	cld
	mov	__psp,es
	mov	_D16InfoSeg,gs

; find our program name

	mov	es,es:[02ch]
	xor	ebx,ebx

fpn@1:
	mov	al,es:[ebx]
	inc	ebx
	or	al,al
	jz	fpn@2
fpn@3:
	mov	al,es:[ebx]
	inc	ebx
	or	al,al
	jnz	fpn@3
	jmp	short fpn@1
fpn@2:

	add	ebx,2
	mov	edi,offset buff
fpn@4:
	mov	al,es:[ebx]
	inc	ebx
	mov	[edi],al
	inc	edi
	or	al,al
	jnz	fpn@4

	push	ds
	pop	es

; open the file for read

	mov	ax,3d00h
	mov	edx,offset buff
	int	21h
	jnc	open_ok

	mov	edx,offset operr
	call	bannerprint
	mov	ax,4c05h
	int	21h

open_ok:
	mov	fhandle,eax

; read EXE block

	mov	ecx,32
	mov	edx,offset buff
	call	read

;******** finally determine whether we can speak or not ********

	mov	al,byte ptr buff+12h
	and	al,1
	mov	silent_flag,al
	jnz	stay_silent

	mov	ah,9
	mov	edx,offset banner
	int	21h
	mov	ah,9
	mov	edx,offset lzmsg1
	int	21h
stay_silent:

; get position of LE

	xor	ecx,ecx
	mov	cx,word ptr buff+4
	shl	ecx,9
	xor	ebx,ebx
	mov	bx,word ptr buff+2
	or	ebx,ebx
	jz	EXE_even_block
	sub	ecx,512
EXE_even_block:
	add	ecx,ebx
	add	ecx,7			;round up to nearest 8
	and	ecx,0fffffff8h

	mov	leoffs,ecx

; seek to, read LE header

	call	seek
	mov	ecx,0ach
	mov	edx,offset buff
	call	read

; check if it's an LE

	cmp	word ptr buff,"EL"
	jz	is_LE

	mov	edx,offset leerr
	call	bannerprint
	mov	ax,4c05h
	int	21h

is_LE:

; seek to end of LE

	mov	ecx,dword ptr buff+80h
	mov	eax,dword ptr buff+14h
	shl	eax,12
	add	ecx,eax
	mov	eax,dword ptr buff+2ch
	or	eax,eax
	jz	even_pages
	sub	ecx,1000h
even_pages:
	add	ecx,eax
	mov	leoffs,ecx

	mov	ax,4200h
	mov	ebx,fhandle
	mov	edx,ecx
	shr	ecx,16
	int	21h
	jc	readerr

; read in VE

	mov	ah,3fh
	mov	ebx,fhandle
	mov	ecx,VEH_LENGTH
	mov	edx,offset buff
	int	21h
	js	readerr
	cmp	eax,VEH_LENGTH
	jb	readerr

; VE?

	cmp	word ptr buff,"EV"
	jz	is_VE

	mov	edx,offset veerr
	call	bannerprint
	mov	ax,4c05h
	int	21h

is_VE:

; allocate enough memory for relocs and program

	mov	ecx,dword ptr buff+veh_uc_image_length
	mov	al,byte ptr buff+veh_image_comp
	cmp	al,veh_ic_max
	jae	comperr
	or	al,al
	jz	no_image_comp
	cmp	dword ptr buff+veh_bss_length,18
	jae	no_image_comp
	add	ecx,18
no_image_comp:
	add	ecx,dword ptr buff+veh_bss_length
	mov	progbsz,ecx

	call	allocmem
	mov	progmem,ebx
	mov	proghnd,esi

	mov	ecx,dword ptr buff+veh_uc_relocs_length
	mov	al,byte ptr buff+veh_relocs_comp
	cmp	al,veh_rl_max
	jae	comperr
	or	al,al
	jz	no_reloc_comp
	add	ecx,19
no_reloc_comp:
	mov	rlocbsz,ecx

	call	allocmem
	mov	rlocmem,ebx
	mov	rlochnd,esi

; read in program image

	mov	ecx,dword ptr buff+veh_image_offset
	add	ecx,leoffs
	call	seek
	mov	ecx,dword ptr buff+veh_image_length
	mov	edx,progmem
	mov	al,byte ptr buff+veh_image_comp
	or	al,al
	jz	no_image_comp_2
	
;it's either LZSS or LZH

	add	edx,progbsz
	sub	edx,dword ptr buff+veh_image_length
	sub	edx,2		;LZH _may_ read two bytes extra, so try to
				;avoid page faults
	push	edx
	call	read
	pop	esi
	mov	edi,progmem
	cmp	byte ptr buff+veh_image_comp,veh_ic_lzh
	jz	image_comp_lzh
	call	delz
	jmp	short image_comp_done
image_comp_lzh:
	mov	eax,dword ptr buff+veh_uc_image_length
	call	delzh
	jmp	short image_finish
image_comp_done:
	mov	edi,progmem
	lea	esi,[edi+19]
	mov	ecx,dword ptr buff+veh_uc_image_length
	mov	eax,ecx
	shr	ecx,2
	rep	movsd
	mov	ecx,eax
	and	ecx,3
	rep	movsb
	jmp	short image_finish

no_image_comp_2:
	call	read
image_finish:

; clear BSS region
; this must be done before relocs due to WLINK's trick
; (see note in LE2VE.C)

	mov	edi,progmem
	add	edi,dword ptr buff+veh_uc_image_length
	mov	ecx,dword ptr buff+veh_bss_length
	mov	ebx,ecx
	xor	eax,eax
	shr	ecx,2
	rep	stosd
	mov	ecx,ebx
	and	ecx,3
	rep	stosb

; do we even have any relocs?  if not, skip this section

	mov	eax,dword ptr buff+veh_uc_relocs_length
	or	eax,eax
	jz	no_relocs

; read in relocs

	mov	ecx,dword ptr buff+veh_relocs_offset
	add	ecx,leoffs
	call	seek
	mov	ecx,dword ptr buff+veh_relocs_length
	mov	edx,rlocmem
	mov	al,byte ptr buff+veh_relocs_comp
	or	al,al
	jz	no_relocs_comp_2

; it's either LZSS or LZH

	add	edx,rlocbsz
	sub	edx,dword ptr buff+veh_relocs_length
	push	edx
	call	read
	pop	esi
	mov	edi,rlocmem

	cmp	byte ptr buff+veh_relocs_comp,veh_rl_lzh
	jz	relocs_comp_lzh
	call	delz
	jmp	short relocs_comp_done
relocs_comp_lzh:
	mov	eax,dword ptr buff+veh_uc_relocs_length
	call	delzh
	jmp	short relocs_load_finish
relocs_comp_done:
	mov	edi,rlocmem
	lea	esi,[edi+19]
	mov	ecx,dword ptr buff+veh_uc_relocs_length
	mov	eax,ecx
	shr	ecx,2
	rep	movsd
	mov	ecx,eax
	and	ecx,3
	rep	movsb
	jmp	short relocs_load_finish

no_relocs_comp_2:
	call	read
relocs_load_finish:

; apply relocs to image

	mov	esi,rlocmem
	mov	edi,progmem
apply_relocs_loop:
	mov	dl,[esi]	;reloc type
	or	dl,dl
	jz	end_apply_relocs
	cmp	dl,4
	jae	invalid_reloc_err
	xor	ecx,ecx
	mov	cx,[esi+1]
	or	ecx,ecx
	jnz	not_zero_relocs
	mov	ecx,00010000h
not_zero_relocs:
	mov	ebx,[esi+3]
	add	esi,7

	;apply the reloc

apply_reloc_loop_2:
	test	dl,1
	jz	not_reloc32
	add	[edi+ebx],edi
	add	ebx,4
not_reloc32:
	test	dl,2
	jz	not_reloc1648
	mov	al,[edi+ebx]
	add	ebx,2
	or	al,al
	jz	useCS
	mov	[edi+ebx-2],ds
	jmp	short not_reloc1648
useCS:
	mov	[edi+ebx-2],cs
not_reloc1648:
	dec	ecx
	jz	apply_relocs_loop
	xor	ebp,ebp
	xor	eax,eax
diff_loop:
	mov	al,[esi]
	inc	esi
	push	eax
	shl	ebp,7
	and	al,7fh
	add	ebp,eax
	pop	eax
	test	al,80h
	jnz	diff_loop
	add	ebx,ebp
	jmp	short apply_reloc_loop_2
end_apply_relocs:

	;free relocs memory

	mov	ax,0502h
	mov	edi,rlochnd
	mov	esi,edi
	shr	esi,16
	int	31h

no_relocs:

	;print message

	mov	edx,offset lzmsg2
	call	carefulprint

	;set stack and ES, call program

	mov	dword ptr svstack,esp
	mov	word ptr svstack+4,ss
	mov	eax,dword ptr buff+veh_stack_point
	add	eax,progmem
	and	eax,0fffffffch
	mov	esp,eax
	mov	eax,dword ptr buff+veh_entry_point
	add	eax,progmem

	;*** SPECIAL CASE FOR VP386 ***
	;
	;if "VP386CHE" is found as the first 20 bytes immediately before the
	;entry point copy over the 20 bytes before our entry point

	cmp	dword ptr [eax-20],"83PV"
	jnz	noVP386
	cmp	dword ptr [eax-16],"EHC6"
	jnz	noVP386
	mov	esi,offset ___checksum
	lea	edi,[eax-20]
	mov	ecx,5
	rep	movsd
noVP386:

	mov	es,__psp	;set ES
	mov	gs,_D16InfoSeg	;set GS
	call	eax   

	;restore stack, exit
	lss	esp,cs:fword ptr svstack

	mov	ax,4c00h
	int	21h

readerr:
	mov	edx,offset rderr
exit_err:
	test	silent_flag,1
	jz	exit_err_2
	push	edx
	mov	ah,9
	mov	edx,offset banner
	int	21h
	pop	edx
exit_err_2:
	mov	ah,9
	int	21h
	mov	ax,4c05h
	int	21h
comperr:
	mov	edx,offset m_comperr
	jmp	short exit_err
memerr:
	mov	edx,offset m_memerr
	jmp	short exit_err
invalid_reloc_err:
	mov	edx,offset m_relctypeerr
	jmp	short exit_err

;**************************************************
;
;	BANNERPRINT
;
;	Prints VELoader banner if silent_flag is enabled, then
;	prints message.
;
;	EDX	string to print
;
;	Destroyed:
;	AH
;

bannerprint:
	test	silent_flag,1
	jz	bannerprint@1
	push	edx
	mov	ah,9
	mov	edx,offset banner
	int	21h
	pop	edx
bannerprint@1:
	mov	ah,9
	int	21h
	ret

;**************************************************
;
;	CAREFULPRINT
;
;	Prints a message only if we don't need to be silent.
;
;	EDX	string to print
;
;	Destroyed:
;	AH
;

carefulprint:
	test	silent_flag,1
	jnz	carefulprint@1
	mov	ah,9
	int	21h
carefulprint@1:
	ret

;**************************************************
;
;	ALLOCMEM
;
;	ECX	number of bytes requested
;
;	Return:
;	EBX	linear address of memory
;	ESI	handle of memory

allocmem:
	mov	ax,0501h
	mov	ebx,ecx
	shr	ebx,16
	int	31h
	jc	memerr
	shl	ebx,16
	mov	bx,cx
	shl	esi,16
	mov	si,di
	ret

;**************************************************
;	SEEK
;
;	ECX	offset to seek to

seek:
	mov	ax,4200h
	mov	ebx,fhandle
	mov	edx,ecx
	shr	ecx,16
	int	21h
	jc	readerr
	ret

;**************************************************
;	READ
;
;	ECX	bytes to read
;	EDX	address to read to

read:
	push	ecx
	mov	ah,3fh
	mov	ebx,fhandle
	int	21h
	jb	readerr
	pop	ecx
	cmp	eax,ecx
	jb	readerr
	ret

;**************************************************
;	DELZ - THE BIG ROUTINE
;
;	EDI - destination memory +19 bytes
;	ESI - source memory
;
;	Modified: EAX EBX ECX EDX ESI EDI EBP

delz:
	cld
	mov	ecx,19			;nulls, for early replication
	xor	eax,eax
	rep	stosb

	mov	ebp,[esi]		;get # of codes
	add	esi,4

_flags	equ	edx

	xor	_flags,_flags
lzd1:
	shr	_flags,1		;next bit
	test	_flags,0100h
	jnz	lzd2
	mov	dl,[esi]		;_flags
	inc	esi
	mov	dh,0ffh			;this is our 8bit count
lzd2:
	test	_flags,1		;literal or replicate?
	jz	lzd3			;jump if replicate
	mov	al,[esi]		;copy next byte
	inc	esi
	mov	[edi],al
	inc	edi
	jmp	short lzd4
lzd3:
	xor	eax,eax
	mov	ax,[esi]		;get replicate word: <hipos-4><len-4><lopos-8>
	add	esi,2
	rol	ah,4			;split word into bits 0-3:length and bits 4-15:position
	mov	ecx,eax
	and	ah,0fh
	shr	ecx,12
	add	ecx,3

	mov	ebx,esi
	lea	esi,[edi+eax-1000h]

	rep	movsb			;not an error - 0xFFF position, for instance, can replicate
	mov	esi,ebx
lzd4:
	dec	ebp
	jne	lzd1

	ret

;**************************************************
;	DELZH - THE HUGE ROUTINE
;
;	EDI - destination memory + 4 bytes (for safety...)
;	ESI - source memory
;	EAX - uncompressed size
;
;	Modified: EAX EBX ECX EDX ESI EDI EBP

delzh:
	cld

	push	eax				;save length
	push	edi				;save destination

	; reconstruct Literal/Distance bit-length tree length table

	mov	edx,offset huff_bllen_tbl
	mov	ecx,8
delzh@1:
	mov	al,[esi]
	inc	esi
	mov	ah,al
	and	ah,15
	mov	[edx],ah
	shr	al,4
	mov	[edx+1],al
	add	edx,2
	dec	ecx
	jnz	delzh@1

	; reconstruct Length tree length table

	mov	edx,offset huff_len_bits
	mov	ecx,11
delzh@2:
	mov	al,[esi]
	inc	esi
	mov	ah,al
	and	ah,15
	mov	[edx],ah
	shr	al,4
	mov	[edx+1],al
	add	edx,2
	dec	ecx
	jnz	delzh@2

; construct a decoding system for the L/D bit-length tree

	; BL		bit level
	; BH		found flag
	; ECX		j
	; EDI		code
	; EDX		code table
	; EBP		code size

	mov	edx,offset huff_ld_code_tbl
	xor	edi,edi
	mov	ebx,1
	mov	ebp,80000000h
delzh@3:
	xor	bh,bh				;found = FALSE
	mov	[ebx*4+huff_ld_start_tbl-4],edx	;store code table ptr
	mov	[ebx*4+huff_ld_first_tbl-4],edi	;store first code
	xor	ecx,ecx
delzh@3a:
	cmp	byte ptr[ecx+huff_bllen_tbl],bl	;same bit level?
	jnz	delzh@3b
	mov	bh,1				;set found flag
	add	edi,ebp				;increment code
	mov	word ptr [edx],cx		;write value to code table
	add	edx,2
delzh@3b:
	inc	ecx
	cmp	ecx,16
	jb	delzh@3a

	xor	eax,eax
	or	bh,bh				;any value for this bit length found?
	jz	delzh@3c			;write 0 for limit if so
	xor	bh,bh
	lea	eax,[edi-1]			;limit = code-1
delzh@3c:
	mov	[ebx*4+huff_ld_last_tbl-4],eax

	shr	ebp,1
	inc	bl				;do bit lengths 1-15
	cmp	bl,16
	jb	delzh@3

	; is the table complete?

	or	edi,edi
	jz	delzh@ldt1_complete
	mov	edx,offset tbl1_incomplete_err
	jmp	exit_err
delzh@ldt1_complete:

; scan the literal/distance table for starting zeroes

	xor	edx,edx
delzh@scan1:
	inc	edx
	cmp	[edx*4+huff_ld_last_tbl-4],0
	jz	delzh@scan1
	dec	edx
	mov	dh,dl

; read in literal/distance tree table

	; EBX		accum
	; DL		accum_bits
	; DH		table start
	; ESI		incoming data pointer
	; EDI		bits table pointer
	; EBP		bits table pointer limit

	mov	edi,offset huff_ld_bits
	mov	ebp,offset huff_ld_bits+280
	xor	ecx,ecx
	xor	ebx,ebx
	xor	dl,dl
delzh@lzt_read:
	cmp	dl,16
	jae	delzh@lztread1
	xor	eax,eax
	mov	ah,[esi]
	mov	al,[esi+1]
	add	esi,2
	mov	cl,16			;shift left by 16-accum_bits
	sub	cl,dl
	shl	eax,cl
	or	ebx,eax			;OR into accum
	add	dl,16			;add 16 to accum_bits
delzh@lztread1:

	mov	cl,dh			;k=0
delzh@lztread2:
	cmp	ebx,[ecx*4+huff_ld_last_tbl]	;find the bit length range accum sits in
	jbe	delzh@lztread3
	inc	cl
	jmp	short delzh@lztread2
delzh@lztread3:
		
	push	[ecx*4+huff_ld_start_tbl]
	mov	eax,ebx
	sub	eax,[ecx*4+huff_ld_first_tbl]
	xor	cl,31
	shr	eax,cl
	xor	cl,31
	add	eax,eax
	add	eax,[esp]
	add	esp,4
	mov	al,[eax]

	inc	cl				;accum_bits -= (k+1)
	sub	dl,cl
	shl	ebx,cl				;accum <<= (k+1)
	mov	[edi],al			;huff_ld_bits[i] = c
	inc	edi

	cmp	edi,ebp
	jb	delzh@lzt_read

	push	edx				;save accum_bits
	push	ebx				;save accum

; construct decoding system for L/D tree

	; BL		bit level
	; BH		found flag
	; ECX		j
	; EDI		code
	; EDX		code table
	; EBP		code size

	mov	edx,offset huff_ld_code_tbl
	xor	edi,edi
	mov	ebx,1
	mov	ebp,80000000h
delzh@4:
	xor	bh,bh				;found = FALSE
	mov	[ebx*4+huff_ld_start_tbl-4],edx	;store code table ptr
	mov	[ebx*4+huff_ld_first_tbl-4],edi	;store first code
	xor	ecx,ecx
delzh@4a:
	cmp	byte ptr [ecx+huff_ld_bits],bl	;same bit level?
	jnz	delzh@4b
	mov	bh,1				;set found flag
	add	edi,ebp				;increment code
	mov	word ptr [edx],cx		;write value to code table
	add	edx,2
delzh@4b:
	inc	ecx
	cmp	ecx,280
	jb	delzh@4a

	xor	eax,eax
	or	bh,bh				;any value for this bit length found?
	jz	delzh@4c			;write 0 for limit if so
	xor	bh,bh
	lea	eax,[edi-1]			;limit = code-1
delzh@4c:
	mov	[ebx*4+huff_ld_last_tbl-4],eax

	shr	ebp,1
	inc	bl				;do bit lengths 1-15
	cmp	bl,16
	jb	delzh@4

	; is the table complete?

	or	edi,edi
	jz	delzh@ldt2_complete
	mov	edx,offset tbl2_incomplete_err
	jmp	exit_err
delzh@ldt2_complete:

; construct decoding system for Length tree

	; BL		bit level
	; BH		found flag
	; ECX		j
	; EDI		code
	; EDX		code table
	; EBP		code size

	mov	edx,offset huff_len_code_tbl
	xor	edi,edi
	mov	ebx,1
	mov	ebp,80000000h
delzh@5:
	xor	bh,bh				;found = FALSE
	mov	[ebx*4+huff_len_start_tbl-4],edx	;store code table ptr
	mov	[ebx*4+huff_len_first_tbl-4],edi	;store first code
	xor	ecx,ecx
delzh@5a:
	cmp	byte ptr[ecx+huff_len_bits],bl	;same bit level?
	jnz	delzh@5b
	mov	bh,1				;set found flag
	add	edi,ebp				;increment code
	mov	byte ptr [edx],cl		;write value to code table
	inc	edx
delzh@5b:
	inc	ecx
	cmp	ecx,22
	jb	delzh@5a

	xor	eax,eax
	or	bh,bh				;any value for this bit length found?
	jz	delzh@5c			;write 0 for limit if so
	xor	bh,bh
	lea	eax,[edi-1]			;limit = code-1
delzh@5c:
	mov	[ebx*4+huff_len_last_tbl-4],eax

	shr	ebp,1
	inc	bl				;do bit lengths 1-15
	cmp	bl,16
	jb	delzh@5

	; is the table complete?

	or	edi,edi
	jz	delzh@ldt3_complete
	mov	edx,offset tbl3_incomplete_err
	jmp	exit_err
delzh@ldt3_complete:

; scan the literal/distance table for starting zeroes

	xor	edx,edx
delzh@scan2:
	inc	edx
	cmp	[edx*4+huff_len_last_tbl-4],0
	jz	delzh@scan2
	dec	edx
	shl	edx,24

; scan the length table for starting zeroes

	xor	eax,eax
delzh@scan3:
	inc	eax
	cmp	[eax*4+huff_ld_last_tbl-4],0
	jz	delzh@scan3
	dec	eax
	mov	dh,al

;****************decompress actual data

	; EBX	accum
	; DL	accum_bits
	; DH	start of table
	; ESI	source
	; EDI	destination
	; EBP	destination limit

	CHKBITS	macro
		local	nope
		cmp	dl,16			;(1u) [1] can we stuff 16 bits in?
		ja	nope			;(1v) [1] no, skip
		xor	eax,eax			;(2u) [2] fetch 16-bits from the data stream
		mov	cl,16			;(2v) [3] shift left by 16-accum_bits
		mov	ah,[esi]		;(3u) [2] Note: Pentium u/v pipes cannot use same DWORD
		sub	cl,dl			;(3v) [3]
		mov	al,[esi+1]		;(4u) [2]
		add	dl,16			;(4v) [4] add 16 to accum_bits
		shl	eax,cl			;(5v) [3]
		or	ebx,eax			;(5u) [5] OR into accum
		add	esi,2			;(6u) [2] fetch 16-bits from the data stream
	nope:
		endm

	pop	ebx			;restore accum
	pop	eax			;restore accum_bits
	mov	dl,al
	pop	edi			;restore destination
	pop	eax			;restore length
	lea	ebp,[edi+eax]
delzh@dataloop:
	CHKBITS

	xor	ecx,ecx			;k=0
	mov	cl,dh
delzh@dread1:
	cmp	ebx,[ecx*4+huff_ld_last_tbl]	;find the bit length range accum sits in
	jbe	delzh@dread2
	inc	cl
	jmp	short delzh@dread1
delzh@dread2:
	
	push	[ecx*4+huff_ld_start_tbl]
	mov	eax,ebx
	sub	eax,[ecx*4+huff_ld_first_tbl]
	xor	cl,31
	shr	eax,cl
	xor	cl,31
	add	eax,eax
	add	eax,[esp]
	add	esp,4
	mov	ax,[eax]

	inc	cl				;accum_bits -= (k+1)
	sub	dl,cl
	shl	ebx,cl				;accum <<= (k+1)

	or	ah,ah				;is it a distance code?
	jnz	delzh@isdist
	mov	[edi],al			;nope, it's a literal
	inc	edi

	cmp	edi,ebp				;all bytes done?
	jb	delzh@dataloop
	jmp	delzh@cleanup

delzh@isdist:					;DOHHHHH!
	and	eax,000000ffh			;distance codes 0-23
	mov	ecx,[eax*4+dist_tbl]		;from = dst-dist_tbl[c]
	neg	ecx
	add	ecx,edi
	push	ecx				;save on stack
	mov	cl,[eax+dist_bits_tbl]		;get number of extra bits
	or	cl,cl
	jz	delzh@nodistxbits		;don't bother if no extra bits
	push	ecx
	CHKBITS
	pop	ecx
	mov	eax,ebx				;from -= accum>>(32-dist_bits_tbl[c]);
	push	ecx
	xor	cl,31
	inc	cl
	shr	eax,cl
	sub	[esp+4],eax
	pop	ecx
	shl	ebx,cl				;accum <<= dist_bits_tbl[c]
	sub	dl,cl				;accum_bits -= dist_bits_tbl[c]
delzh@nodistxbits:

	; read length in

	CHKBITS

;	xor	ecx,ecx			;k=0
	mov	ecx,edx
	shr	ecx,24
delzh@dread3:
	cmp	ebx,[ecx*4+huff_len_last_tbl]	;find the bit length range accum sits in
	jbe	delzh@dread4
	inc	cl
	jmp	short delzh@dread3
delzh@dread4:
	push	[ecx*4+huff_len_start_tbl]
	mov	eax,ebx
	sub	eax,[ecx*4+huff_len_first_tbl]
	xor	cl,31
	shr	eax,cl
	xor	cl,31
	add	eax,[esp]
	add	esp,4
	mov	al,[eax]

	inc	cl				;[1] accum_bits -= (k+1)
	and	eax,000000ffh	;(moved from below)
	shl	ebx,cl				;[2] accum <<= (k+1)
	sub	dl,cl				;[1]

			;and eax,0ffh instruction moved up for Pentium opt.
	push	dword ptr [eax*4+len_tbl]	;save len_tbl[c]
	mov	cl,[eax+len_bits_tbl]
	or	cl,cl				;any Xbits for length?
	jz	delzh@nolenxbits

	;get Xbits for length

	push	ecx
	CHKBITS
	pop	ecx
	mov	eax,ebx				;bc += accum>>(32-dist_bits_tbl[c]);
	push	ecx
	xor	cl,31
	inc	cl
	shr	eax,cl
	add	[esp+4],eax
	pop	ecx
	shl	ebx,cl				;accum <<= len_bits_tbl[c]
	sub	dl,cl				;accum_bits -= len_bits_tbl[c]
delzh@nolenxbits:

	;FINALLY do the copy

	push	esi
	mov	esi,[esp+8]
	mov	ecx,[esp+4]
	rep	movsb
	pop	esi
	add	esp,8

	;continue loop

	cmp	edi,ebp				;all bytes done?
	jb	delzh@dataloop
	jmp	delzh@cleanup


delzh@cleanup:

	ret

;*******************************************

	align	4

dist_tbl	dd	1,2,3,4,5,7,9,13,17,25,33,49,65,97,129,193,257,385,513,769,1025,1537,2049,3073
len_tbl		dd	3,4,5,6,7,8,9,10,11,13,15,17,19,23,27,31,35,43,51,59,67,83
dist_bits_tbl	db	0,0,0,0,1,1,2,2,3,3,4,4,5,5,6,6,7,7,8,8,9,9,10,10
len_bits_tbl	db	0,0,0,0,0,0,0,0,1,1,1,1,2,2,2,2,3,3,3,3,4,0

banner			db	"VELoader V1.21 by Avery Lee: $"
lzmsg1			db	"loading program...$"
lzmsg2			db	"done!",13,10,"$"
operr			db	"Can't open file for read",13,10,"$"
rderr			db	"Can't read EXE file",13,10,"$"
leerr			db	"LE header not found.",13,10,"$"
veerr			db	"VE header not found.",13,10,"$"
m_comperr		db	"Invalid compression type.",13,10,"$"
m_memerr		db	"Not enough memory.",13,10,"$"
m_relctypeerr		db	"Invalid reloc type.",13,10,"$"
tbl1_incomplete_err	db	"L/D-bitlen table incomplete.",13,10,"$"
tbl2_incomplete_err	db	"L/D table incomplete.",13,10,"$"
tbl3_incomplete_err	db	"Length table incomplete.",13,10,"$"

	end	_cstart_
